/*
 * API documentation
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0-20181108155220-20181108155343
 * Contact: api.move@axa-assistance.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.insurance.bn.starter.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.util.Objects;

/**
 * Travel covered by the policy.
 */
@ApiModel(description = "Travel covered by the policy.")
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2018-12-19T23:23:06.995+01:00")
public class Travel {
  @SerializedName("journeys")
  private Journeys journeys = null;

  @SerializedName("cost")
  private Model40 cost = null;

  @SerializedName("destination_area")
  private String destinationArea = null;

  @SerializedName("travelers")
  private Travelers travelers = null;

  @SerializedName("start_date")
  private String startDate = null;

  @SerializedName("end_date")
  private String endDate = null;

  @SerializedName("booking_date")
  private String bookingDate = null;

  public Travel journeys(Journeys journeys) {
    this.journeys = journeys;
    return this;
  }

   /**
   * Get journeys
   * @return journeys
  **/
  @ApiModelProperty(value = "")
  public Journeys getJourneys() {
    return journeys;
  }

  public void setJourneys(Journeys journeys) {
    this.journeys = journeys;
  }

  public Travel cost(Model40 cost) {
    this.cost = cost;
    return this;
  }

   /**
   * Get cost
   * @return cost
  **/
  @ApiModelProperty(value = "")
  public Model40 getCost() {
    return cost;
  }

  public void setCost(Model40 cost) {
    this.cost = cost;
  }

  public Travel destinationArea(String destinationArea) {
    this.destinationArea = destinationArea;
    return this;
  }

   /**
   * Global destination area. For example FRANCE, EUROPE, WORLDWIDE EXCLUDING USA &amp; CANADA, WORLDWIDE INCLUDING USA &amp; CANADA.
   * @return destinationArea
  **/
  @ApiModelProperty(value = "Global destination area. For example FRANCE, EUROPE, WORLDWIDE EXCLUDING USA & CANADA, WORLDWIDE INCLUDING USA & CANADA.")
  public String getDestinationArea() {
    return destinationArea;
  }

  public void setDestinationArea(String destinationArea) {
    this.destinationArea = destinationArea;
  }

  public Travel travelers(Travelers travelers) {
    this.travelers = travelers;
    return this;
  }

   /**
   * Get travelers
   * @return travelers
  **/
  @ApiModelProperty(value = "")
  public Travelers getTravelers() {
    return travelers;
  }

  public void setTravelers(Travelers travelers) {
    this.travelers = travelers;
  }

  public Travel startDate(String startDate) {
    this.startDate = startDate;
    return this;
  }

   /**
   * Start date of the travel - ISO 8601 format (YYYY-MM-DD).
   * @return startDate
  **/
  @ApiModelProperty(required = true, value = "Start date of the travel - ISO 8601 format (YYYY-MM-DD).")
  public String getStartDate() {
    return startDate;
  }

  public void setStartDate(String startDate) {
    this.startDate = startDate;
  }

  public Travel endDate(String endDate) {
    this.endDate = endDate;
    return this;
  }

   /**
   * End date of the travel - ISO 8601 format (YYYY-MM-DD).
   * @return endDate
  **/
  @ApiModelProperty(value = "End date of the travel - ISO 8601 format (YYYY-MM-DD).")
  public String getEndDate() {
    return endDate;
  }

  public void setEndDate(String endDate) {
    this.endDate = endDate;
  }

  public Travel bookingDate(String bookingDate) {
    this.bookingDate = bookingDate;
    return this;
  }

   /**
   * Travel booking date.  ISO 8601 format (YYYY-MM-DD).
   * @return bookingDate
  **/
  @ApiModelProperty(value = "Travel booking date.  ISO 8601 format (YYYY-MM-DD).")
  public String getBookingDate() {
    return bookingDate;
  }

  public void setBookingDate(String bookingDate) {
    this.bookingDate = bookingDate;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Travel travel = (Travel) o;
    return Objects.equals(this.journeys, travel.journeys) &&
        Objects.equals(this.cost, travel.cost) &&
        Objects.equals(this.destinationArea, travel.destinationArea) &&
        Objects.equals(this.travelers, travel.travelers) &&
        Objects.equals(this.startDate, travel.startDate) &&
        Objects.equals(this.endDate, travel.endDate) &&
        Objects.equals(this.bookingDate, travel.bookingDate);
  }

  @Override
  public int hashCode() {
    return Objects.hash(journeys, cost, destinationArea, travelers, startDate, endDate, bookingDate);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Travel {\n");
    
    sb.append("    journeys: ").append(toIndentedString(journeys)).append("\n");
    sb.append("    cost: ").append(toIndentedString(cost)).append("\n");
    sb.append("    destinationArea: ").append(toIndentedString(destinationArea)).append("\n");
    sb.append("    travelers: ").append(toIndentedString(travelers)).append("\n");
    sb.append("    startDate: ").append(toIndentedString(startDate)).append("\n");
    sb.append("    endDate: ").append(toIndentedString(endDate)).append("\n");
    sb.append("    bookingDate: ").append(toIndentedString(bookingDate)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

